SuperStrict

Import sidesign.minib3d

AppTitle = "Milkyway Demo"

Graphics3D 800,600,32,2

ClearTextureFilters()

Include "include/milkyway.bmx"

' camera
Global cam:TCamera = CreateCamera()
PositionEntity cam,0,0,-25

' sun
Global suntex:TTexture = CreateSunTexture()
Local size:Float = 1.0
Global SUN:TPivot = CreatePivot()
Global SUN0:TMesh = CreateQuad(size * 1.0, suntex, 3, 1 + 8, 255, 255, 255, 1.00)
Global SUN1:TMesh = CreateQuad(size * 1.5, suntex, 3, 1 + 8, 255, 192, 128, 1.00)
Global SUN2:TMesh = CreateQuad(size * 3.0, suntex, 3, 1 + 8, 255, 255, 224, 0.75)
Global SUN3:TMesh = CreateQuad(size * 15.0, suntex, 3, 1 + 8, 255, 255, 224, 0.50)
EntityParent SUN0, SUN
EntityParent SUN1, SUN
EntityParent SUN2, SUN
EntityParent SUN3, SUN
PositionEntity SUN, 0, 0, 0

' milkyway
Global milkyway:TPivot = InitMilkyway(500, 0.2, 10, 40, 100, 0, 0, 0, 0, 255, 192, 128, 0.5, 0, 0, 0, 0)

MoveMouse GraphicsWidth() / 2, GraphicsHeight() / 2
' ----------------------------------------------------------------------------
' Main Loop
' ----------------------------------------------------------------------------
While Not AppTerminate()

	Cls
	
	' Escape = Terminate
	If KeyHit(KEY_ESCAPE) Then End
	
	' milkway holds position
	'PositionEntity milkyway, EntityX(cam, 1), EntityY(cam, 1), EntityZ(cam, 1)
		
	' points
	PointEntity SUN, cam
				
	UpdateWorld
	RenderWorld
		
	Flip True

Wend

End

Function CreateQuad:TMesh(scale:Float = 1.0, tex:TTexture = Null, blend:Int = 0, fx:Int = 0, r:Int = 255, g:Int = 255, b:Int = 255, a:Float = 1.0)
	
	Local mesh:TMesh = CreateMesh()
	Local surf:TSurface = CreateSurface(mesh)
	
	Local v0:Int = AddVertex(surf, 1, 1, 0, 0, 0)
	Local v1:Int = AddVertex(surf, -1, 1, 0, 1, 0)
	Local v2:Int = AddVertex(surf, -1, -1, 0, 1, 1)
	Local v3:Int = AddVertex(surf, 1, -1, 0, 0, 1)
	
	AddTriangle surf, v0, v1, v2
	AddTriangle surf, v0, v2, v3
	
	If fx Then EntityFX Mesh, fx
	If tex Then EntityTexture Mesh, tex
	If blend Then EntityBlend Mesh, blend
	
	EntityColor mesh, r, g, b
	EntityAlpha mesh, a
	
	VertexColor surf, v0, r, g, b, a
	VertexColor surf, v1, r, g, b, a
	VertexColor surf, v2, r, g, b, a
	VertexColor surf, v3, r, g, b, a
	
	ScaleEntity mesh, scale, scale, scale
		
	Return mesh
		
End Function

Function CreateSunTexture:TTexture()
	
	Local pixmap:TPixmap = CreatePixmap(512, 512, PF_RGBA8888)
	
	Local i:Float, j:Int, col:Int, rgb:Int
	
	For j = 0 To 255
		
		col=255-j
		If col > 255 Then col = 255
		rgb=col*$1000000+col*$10000+col*$100+col
		
		For i=0 To 360 Step 0.1
			
			WritePixel(pixmap, 256 + (Sin(i) * j), 256 + (Cos(i) * j), rgb)
			
		Next
		
	Next
	
	SavePixmapPNG(pixmap, "textures/sun.png")
	
	Local tex:TTexture = LoadTexture("textures/sun.png", 2 + 8)
	
	Return tex
	
End Function

Function Normalize:Float(value:Float = 128.0, value_min:Float = 0.0, value_max:Float = 255.0, norm_min:Float = 0.0, norm_max:Float = 1.0)
	
	Return ((value:Float - value_min:Float) / (value_max:Float - value_min:Float)) * (norm_max:Float - norm_min:Float) + norm_min:Float
		
End Function